<?php
/*
Original Plugin Name: Yet Another Advanced Paged Navigation
Plugin URI: http://dreamincolours.com/projects/wordpress-plugins/yaapn/
Description: Heavily customizable paged navigation, localized by J.Kretzschmar for dKret2
Version: 1.05
Author: Monika "YaaL" Szczygieł
Author URI: http://dreamincolours.com
*/


function dKretPaging() {
global $request, $posts_per_page, $wpdb, $paged, $max_num_pages, $wp_query;

$template='<div class="paging"><h4>'.__('Page','dkret').' %CURRENT% '.__('of','dkret').' %COUNT%</h4> <ul>%FIRST% %PREV*% %SKIPB% %NUMBERED% %SKIPA% %NEXT*% %LAST%</ul></div>'; 
$template_item='<li>%ITEM%</li>';
$count=2;
$prevlabel=__('&lsaquo; Previous','dkret'); 
$currentlabel='<b>%NUMBER%</b>';
$nextlabel=__('Next &rsaquo;','dkret');
$firstlabel=__('Start','dkret'); 
$numberedlabel='%NUMBER%';
$lastlabel=__('End','dkret'); 
$skipped='<li> ... </li>';
$separator='';  

	if (!is_single()):
    $max_page=999999;
		if (get_query_var('what_to_show') == 'posts'):
			preg_match('#FROM\s(.*)\sGROUP BY#siU', $request, $matches);
			$fromwhere = $matches[1];
			$numposts = $wpdb->get_var("SELECT COUNT(DISTINCT ID) FROM $fromwhere");
			$max_page = ceil($numposts /$posts_per_page);
		elseif ( isset($max_num_pages) ):
			$max_page = $max_num_pages;
		else:
			$max_page = ceil($wp_query->max_num_pages);
		endif;
		
		if (empty($paged))
			$paged = 1;

		if ($count==0 || $count>$max_page)
			$count = $max_page;
		
		$skipb = $skipa = '';
		$prevlink	= (($paged<=1) ? '' : '<li><a href="'.get_pagenum_link($paged-1).'">'.$prevlabel.'</a></li>');
		$prevnotfirstlink = (($paged<=2) ? '' : '<li><a href="'.get_pagenum_link($paged-1).'">'.$prevlabel.'</a></li>');
		$nextlink = (($paged==$max_page) ? '' : '<li><a href="'.get_pagenum_link($paged+1).'">'.$nextlabel.'</a></li>');
		$nextnotlastlink = (($paged>=$max_page-1) ? '' : '<li><a href="'.get_pagenum_link($paged+1).'">'.$nextlabel.'</a></li>');
		$firstlink = (($paged<=1) ? '' : '<li><a href="'.get_pagenum_link().'">'. $firstlabel.'</a></li>');
		$lastlink = (($paged==$max_page)? '' : '<li><a href="'.get_pagenum_link($max_page).'">'.$lastlabel.'</a></li>');
		
    $currentlabel = str_replace('%NUMBER%', $paged, $currentlabel);

		$result = '';
		if ($max_page > 1):
			if ( ($paged -$count) > 1)
				$skipb = $skipped;

			$numbered='';
   		for($i = ($paged - $count); $i <= ($paged + $count); $i++):
	  		if ( $i >= 1 && $i <= $max_page):
//		  		$numbered .= str_replace('%NUMBER%', $i, $beforelink). (($i == $paged) ? $currentlabel : '<a href="'.get_pagenum_link($i).'">'. str_replace('%NUMBER%', $i, $numberedlabel) .'</a>' ) . str_replace('%NUMBER%', $i, $afterlink);
					$label = (($i == $paged) ? $currentlabel : '<a href="'.get_pagenum_link($i).'">'. str_replace('%NUMBER%', $i, $numberedlabel) .'</a>' );
		  		$numbered .= str_replace(array('%ITEM%', '%NUMBER%'), array($label, $i), $template_item);
			  endif;
				
 				if ($i >= 1 && $i < min($paged+$count, $max_page)):
  				$numbered .= $separator;
	  		endif;
		  endfor;

			if (($paged + $count) < $max_page)
				$skipa = $skipped;
			
			$result = str_replace(
				array('%COUNT%', '%CURRENT%', '%PREV%', '%PREV*%', '%NEXT%', '%NEXT*%', '%FIRST%', '%LAST%', '%NUMBERED%', '%SKIPB%', '%SKIPA%'),
				array($max_page, $paged, $prevlink, $prevnotfirstlink, $nextlink, $nextnotlastlink, $firstlink, $lastlink, $numbered, $skipb, $skipa),
				$template);
			echo $result;
		endif;

	endif;
}
?>
