<?php get_header(); ?>

<!-- Blog content -->
<div id="content">
	
	<h2><?php _e('My Books','dkret'); ?></h2>
	
	<?php if( can_now_reading_admin() ) : ?>
		
		<p><?php _e('Admin','dkret'); ?>: &raquo; <a href="<?php manage_library_url() ?>"><?php _e('Manage Books','dkret'); ?></a></p>
		
	<?php endif; ?>

	<?php if( have_books('status=reading&num=-1') ) : ?>
		<h3><?php _e('Current','dkret'); ?> (<?php echo total_books('reading', 0) ?>):</h3>
	
		<?php while( have_books('status=reading&num=-1') ) : the_book(); ?>

      <div class="book">			
    		<a href="<?php book_permalink() ?>" alt="<?php book_title() ?>" title="<?php book_author() ?>: <?php book_title() ?>"><img width="100" height="170" class="alignleft" src="<?php book_image() ?>" alt="<?php book_title() ?>" /></a>
    		<a href="<?php book_permalink() ?>"><?php book_title() ?></a> <br /><p><?php _e('by','dkret'); ?> <a href="<?php book_author_permalink() ?>"><?php book_author() ?></a></p>
      </div>
			
		<?php endwhile; ?>
		
	<?php endif; ?>


	<?php if( have_books('status=unread&num=-1') ) : ?>

    <h3><?php _e('Planned Books','dkret'); ?> (<?php echo total_books('unread', 0) ?>):</h3>
	
			<?php while( have_books('status=unread&num=-1') ) : the_book(); ?>
        <div class="book">	
          <a href="<?php book_permalink() ?>" alt="<?php book_title() ?>" title="<?php book_author() ?>: <?php book_title() ?>"><img width="100" height="170" class="alignleft" src="<?php book_image() ?>" alt="<?php book_title() ?>" /></a>
      		<a href="<?php book_permalink() ?>"><?php book_title() ?></a> <br /><p><?php _e('by','dkret'); ?> <a href="<?php book_author_permalink() ?>"><?php book_author() ?></a></p>
        </div>
      <?php endwhile; ?>
		
	<?php endif; ?>



	<?php if( have_books('status=read&orderby=finished&order=desc&num=8') ) : ?>
    <h3><?php _e('Recent Books','dkret'); ?> (<?php echo total_books('read', 0) ?>):</h3>

      <div class="book">		
  			<?php while( have_books('status=read&orderby=finished&order=desc&num=-1') ) : the_book(); ?>
          <a href="<?php book_permalink() ?>" alt="<?php book_title() ?>" title="<?php book_author() ?>: <?php book_title() ?>"><img class="alignleft" src="<?php book_image() ?>" width="100" height="170" /></a>
        <?php endwhile; ?>
      </div>
  
      <div class="book">		
  		  <?php $count = 0; while( have_books('status=read&orderby=finished&order=desc&num=-1') ) : the_book(); ?>
          <?php $count++; if ($count < 9) {} else { ?>
            <ul>
              <li><a href="<?php book_permalink() ?>" title="<?php book_author() ?>: <?php book_title() ?>"><?php book_title() ?></a> (<?php book_author() ?>)</li>
            </ul>
          <?php } ?>
        <?php endwhile; ?>
      </div>
		
	<?php endif; ?>



<!--
  <div class="infoblock"><?php total_books(); ?> <?php _e('overall','dkret'); ?>; <?php books_read_since('1 year') ?> <?php _e('read in the last year','dkret'); ?>; <?php books_read_since('1 month') ?> <?php _e('read in the last month.','dkret'); ?></div>
-->
		
	<p class="space"><?php do_action('nr_footer'); ?></p>
		
</div>

<?php get_sidebar() ?>

<?php get_footer() ?>
