<?php
/*
Plugin Name: dKret todo widget
Description: A todo list widget (needs plugin to show up).
Author: J. Kretzschmar
Version: 1.2
Author URI: http://diekretzschmars.de
*/

if (!function_exists('ourtodolist_exists'))
	return;

function widget_dkret_todo($args) {
	extract($args);
	$options = get_option('widget_dkret_todo'); ?>
  <div id="todo">
    <?php if (function_exists('ourtodolist_all')) { ?>
      <?php if (ourtodolist_exists(OTD_ALL)) { ?>
        <h2 class="widget_title"><?php echo ($options['title']) ?></h2>
        <ul>
          <?php ourtodolist(intval($options['todo']), false, false); ?>
          <?php ourtodolist_completed(intval($options['finished']), false, false); ?>        
        </ul>
      <?php }
    } ?>
  </div>
<?php }

// Admin section
function widget_control_dkret_todo() {
 	global $wpdb;
 	$options = get_option('widget_dkret_todo');
    		
	if ( $_POST['dkret-submit'] ) {

		$options['title'] = strip_tags(stripslashes($_POST['dkret-todo-title']));
		$options['todo'] = trim($_POST['dkret-todo-todo']);
		$options['finished'] = trim($_POST['dkret-todo-finished']);
		update_option('widget_dkret_todo', $options);
	}
	
	$title = htmlspecialchars($options['title'], ENT_QUOTES);
	$todo = $options['todo'];
	$finished = $options['finished'];

	// The Box content
	echo '<p style="text-align:right;"><label for="dkret-todo-title" />' . __('Title:', 'dkret') . ' <input style="width: 200px;" id="dkret-todo-title" name="dkret-todo-title" type="text" value="'.$title.'" /></p>';
  echo '<p style="text-align:right;"><label for="dkret-todo-todo" />' . __('Todo Tasks:', 'dkret') . ' <input size="2" id="dkret-todo-todo" name="dkret-todo-todo" type="text" value="'.$todo.'" /></p>';
	echo '<p style="text-align:right;"><label for="dkret-todo-finished" />' . __('Finished Tasks:', 'dkret') . ' <input size="2" id="dkret-todo-finished" name="dkret-todo-finished" type="text" value="'.$finished.'" /></p>';
  echo '<input type="hidden" id="dkret-submit" name="dkret-submit" value="1" />';
}

$options = get_option('widget_dkret_todo');
if ( !is_array($options) )
	$options = array('title'=>''. __('Todo Tasks', 'dkret') .'','todo'=>'3','finished'=>'3',);
	update_option('widget_dkret_todo', $options);

register_sidebar_widget(__('dKret: Todo','dkret'), 'widget_dkret_todo');
register_widget_control(__('dKret: Todo','dkret'), 'widget_control_dkret_todo', 300, 200);
?>
