<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head profile="http://gmpg.org/xfn/11">

  <?php if (isset($g2data['headHtml'])) {
    list($g2_title, $g2_css, $g2_javascript) = GalleryEmbed::parseHead($g2data['headHtml']);
    foreach ($g2_css as $css) { echo "$css \r\n"; }
    foreach ($g2_javascript as $javascript) { echo "$javascript \r\n"; }
  } ?>

	<meta http-equiv="Content-Type" content="<?php bloginfo('html_type'); ?>; charset=<?php bloginfo('charset'); ?>" />

	<title><?php bloginfo('name'); ?> &raquo; <?php echo $g2_title; ?></title>

	<meta name="generator" content="WordPress <?php bloginfo('version'); ?>" />

	<link rel="stylesheet" href="<?php bloginfo('template_directory'); ?>/style-g2.css" type="text/css" media="screen" />

	<?php /*Let's get the custom CSS */ if (get_option('dkret_scheme') != '') { ?>
  	<link rel="stylesheet" type="text/css" media="screen" href="<?php dkretinfo('scheme'); ?>" />
	<?php } ?>

	<link rel="alternate" type="application/rss+xml" title="<?php bloginfo('name'); ?> RSS Feed" href="<?php bloginfo('rss2_url'); ?>" />
	<link rel="pingback" href="<?php bloginfo('pingback_url'); ?>" />
	<link rel="SHORTCUT ICON" href="<?php bloginfo('template_directory'); ?>/images/favicon.ico" />

<?php global $ec3; $ec3->nocss=true; ?>
<?php wp_head(); ?> 

</head>

<body>

<!-- container for content and sidebar-->
<div id="container">

	<!-- header -->
	<div id="header">
	<?php if( get_option('dkret_header_text' ) == 1 ) { ?>
    <div id="headertitle">
     	<h1 class="title"><a href="<?php echo get_settings('home'); ?>/"><?php bloginfo('name'); ?></a></h1>
     	<h2 class="title"><?php bloginfo('description'); ?></h2>
    </div>
	<?php } ?>
	</div>

  <div id="navigation">
		<a href="<?php bloginfo('rss2_url'); ?>" class="feedicon">RSS</a>
		<ul id="topnavi">
			<li><a href="<?php echo get_settings('home'); ?>"><?php _e('Start','dkret'); ?></a></li>
      <?php // Gallery2 link if plugin is installed
      if ((function_exists('g2_sidebarimageblock')) && (get_option('dkret_gallery2') == 1)) { ?>
  			<li><a href="<?php echo get_settings('home'); ?>/wp-gallery2.php"><?php _e('Gallery','dkret'); ?></a></li>
			<?php } ?>
      <?php // Library link if Now-Reading Plugin is installed
      if ((function_exists('library_url')) && (get_option('dkret_nowreading') == 1))  { ?>
			 <li><a href="<?php library_url() ?>"><?php _e('My Books','dkret'); ?></a></li>
      <?php	}
			if (function_exists('gdm_list_selected_pages')) {
        gdm_list_selected_pages('sort_column=menu_order&depth=1&title_li='); 
      } else {
        wp_list_pages('sort_column=menu_order&depth=1&title_li=');
      }?>
		</ul>

    <?php if( get_option( 'dkret_header_subnavigation' ) == 1 ) {	
      global $post;
      global $wpdb;
      if (is_page()) {
          $current_page = $post->ID;
          $parent = $wpdb->get_var("SELECT post_parent FROM $wpdb->posts WHERE ID = '$current_page'");
    
          if((wp_list_pages("child_of=".$current_page."&echo=0")) || ($parent != 0)) { ?>
            <ul id="subnavi">
              <?php if($parent != 0) { ?>
                <li><a href="<?php echo get_permalink($parent); ?>" title="<?php _e('back','dkret'); ?>" class="back"><?php _e('&laquo;','dkret'); ?></a></li>
              <?php }
              if (function_exists('gdm_list_selected_pages')) {
              gdm_list_selected_pages("sort_column=menu_order&title_li=&depth=1&child_of=".$current_page);              
              } else {
              wp_list_pages("sort_column=menu_order&title_li=&depth=1&child_of=".$current_page); 
              } ?>
            </ul>
          <?php }
      }
    } ?>
		
  </div>
<!--header end-->

  <div id="wpg2content">
